#ifndef _H_A2A20A1C34035EAA7A26FFD432305B12_GetMetadata__H_
#define _H_A2A20A1C34035EAA7A26FFD432305B12_GetMetadata__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "ouster_msgs/msg/dds_opensplice/Metadata_.h"


namespace ouster_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetMetadata_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<GetMetadata_Request_> GetMetadata_Request__var;
            typedef GetMetadata_Request_& GetMetadata_Request__out;

            struct  GetMetadata_Response_
            {
                ::ouster_msgs::msg::dds_::Metadata_ metadata_;
            };

            typedef DDS_DCPSStruct_var<GetMetadata_Response_> GetMetadata_Response__var;
            typedef DDS_DCPSStruct_out < GetMetadata_Response_> GetMetadata_Response__out;

            struct  Sample_GetMetadata_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ouster_msgs::srv::dds_::GetMetadata_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetMetadata_Request_> Sample_GetMetadata_Request__var;
            typedef Sample_GetMetadata_Request_& Sample_GetMetadata_Request__out;

            struct  Sample_GetMetadata_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::ouster_msgs::srv::dds_::GetMetadata_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetMetadata_Response_> Sample_GetMetadata_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetMetadata_Response_> Sample_GetMetadata_Response__out;

        }

    }

}

#endif /* _H_A2A20A1C34035EAA7A26FFD432305B12_GetMetadata__H_ */
