#ifndef _H_A2A20A1C34035EAA7A26FFD432305B12_GetMetadata_DCPS_H_
#define _H_A2A20A1C34035EAA7A26FFD432305B12_GetMetadata_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetMetadata_.h"


namespace ouster_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetMetadata_Request_TypeSupportInterface;

            typedef GetMetadata_Request_TypeSupportInterface * GetMetadata_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetMetadata_Request_TypeSupportInterface> GetMetadata_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetMetadata_Request_TypeSupportInterface> GetMetadata_Request_TypeSupportInterface_out;


            class GetMetadata_Request_DataWriter;

            typedef GetMetadata_Request_DataWriter * GetMetadata_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetMetadata_Request_DataWriter> GetMetadata_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetMetadata_Request_DataWriter> GetMetadata_Request_DataWriter_out;


            class GetMetadata_Request_DataReader;

            typedef GetMetadata_Request_DataReader * GetMetadata_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetMetadata_Request_DataReader> GetMetadata_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetMetadata_Request_DataReader> GetMetadata_Request_DataReader_out;


            class GetMetadata_Request_DataReaderView;

            typedef GetMetadata_Request_DataReaderView * GetMetadata_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetMetadata_Request_DataReaderView> GetMetadata_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetMetadata_Request_DataReaderView> GetMetadata_Request_DataReaderView_out;

            struct GetMetadata_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetMetadata_Request_, struct GetMetadata_Request_Seq_uniq_> GetMetadata_Request_Seq;
            typedef DDS_DCPSSequence_var < GetMetadata_Request_Seq> GetMetadata_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetMetadata_Request_Seq> GetMetadata_Request_Seq_out;

            class  GetMetadata_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetMetadata_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetMetadata_Request_TypeSupportInterface_var _var_type;

                static GetMetadata_Request_TypeSupportInterface_ptr _duplicate (GetMetadata_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetMetadata_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetMetadata_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetMetadata_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetMetadata_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetMetadata_Request_TypeSupportInterface () {};
                ~GetMetadata_Request_TypeSupportInterface () {};
            private:
                GetMetadata_Request_TypeSupportInterface (const GetMetadata_Request_TypeSupportInterface &);
                GetMetadata_Request_TypeSupportInterface & operator = (const GetMetadata_Request_TypeSupportInterface &);
            };

            class  GetMetadata_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetMetadata_Request_DataWriter_ptr _ptr_type;
                typedef GetMetadata_Request_DataWriter_var _var_type;

                static GetMetadata_Request_DataWriter_ptr _duplicate (GetMetadata_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetMetadata_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetMetadata_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetMetadata_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetMetadata_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetMetadata_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetMetadata_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetMetadata_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetMetadata_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetMetadata_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetMetadata_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetMetadata_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetMetadata_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetMetadata_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetMetadata_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetMetadata_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetMetadata_Request_& instance_data) = 0;

            protected:
                GetMetadata_Request_DataWriter () {};
                ~GetMetadata_Request_DataWriter () {};
            private:
                GetMetadata_Request_DataWriter (const GetMetadata_Request_DataWriter &);
                GetMetadata_Request_DataWriter & operator = (const GetMetadata_Request_DataWriter &);
            };

            class  GetMetadata_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetMetadata_Request_DataReader_ptr _ptr_type;
                typedef GetMetadata_Request_DataReader_var _var_type;

                static GetMetadata_Request_DataReader_ptr _duplicate (GetMetadata_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetMetadata_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetMetadata_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetMetadata_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetMetadata_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetMetadata_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetMetadata_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetMetadata_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetMetadata_Request_& instance) = 0;

            protected:
                GetMetadata_Request_DataReader () {};
                ~GetMetadata_Request_DataReader () {};
            private:
                GetMetadata_Request_DataReader (const GetMetadata_Request_DataReader &);
                GetMetadata_Request_DataReader & operator = (const GetMetadata_Request_DataReader &);
            };

            class  GetMetadata_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetMetadata_Request_DataReaderView_ptr _ptr_type;
                typedef GetMetadata_Request_DataReaderView_var _var_type;

                static GetMetadata_Request_DataReaderView_ptr _duplicate (GetMetadata_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetMetadata_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetMetadata_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetMetadata_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetMetadata_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetMetadata_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetMetadata_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetMetadata_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetMetadata_Request_& instance) = 0;

            protected:
                GetMetadata_Request_DataReaderView () {};
                ~GetMetadata_Request_DataReaderView () {};
            private:
                GetMetadata_Request_DataReaderView (const GetMetadata_Request_DataReaderView &);
                GetMetadata_Request_DataReaderView & operator = (const GetMetadata_Request_DataReaderView &);
            };
            class GetMetadata_Response_TypeSupportInterface;

            typedef GetMetadata_Response_TypeSupportInterface * GetMetadata_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetMetadata_Response_TypeSupportInterface> GetMetadata_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetMetadata_Response_TypeSupportInterface> GetMetadata_Response_TypeSupportInterface_out;


            class GetMetadata_Response_DataWriter;

            typedef GetMetadata_Response_DataWriter * GetMetadata_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetMetadata_Response_DataWriter> GetMetadata_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetMetadata_Response_DataWriter> GetMetadata_Response_DataWriter_out;


            class GetMetadata_Response_DataReader;

            typedef GetMetadata_Response_DataReader * GetMetadata_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetMetadata_Response_DataReader> GetMetadata_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetMetadata_Response_DataReader> GetMetadata_Response_DataReader_out;


            class GetMetadata_Response_DataReaderView;

            typedef GetMetadata_Response_DataReaderView * GetMetadata_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetMetadata_Response_DataReaderView> GetMetadata_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetMetadata_Response_DataReaderView> GetMetadata_Response_DataReaderView_out;

            struct GetMetadata_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetMetadata_Response_, struct GetMetadata_Response_Seq_uniq_> GetMetadata_Response_Seq;
            typedef DDS_DCPSSequence_var < GetMetadata_Response_Seq> GetMetadata_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetMetadata_Response_Seq> GetMetadata_Response_Seq_out;

            class  GetMetadata_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetMetadata_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetMetadata_Response_TypeSupportInterface_var _var_type;

                static GetMetadata_Response_TypeSupportInterface_ptr _duplicate (GetMetadata_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetMetadata_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetMetadata_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetMetadata_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetMetadata_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetMetadata_Response_TypeSupportInterface () {};
                ~GetMetadata_Response_TypeSupportInterface () {};
            private:
                GetMetadata_Response_TypeSupportInterface (const GetMetadata_Response_TypeSupportInterface &);
                GetMetadata_Response_TypeSupportInterface & operator = (const GetMetadata_Response_TypeSupportInterface &);
            };

            class  GetMetadata_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetMetadata_Response_DataWriter_ptr _ptr_type;
                typedef GetMetadata_Response_DataWriter_var _var_type;

                static GetMetadata_Response_DataWriter_ptr _duplicate (GetMetadata_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetMetadata_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetMetadata_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetMetadata_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetMetadata_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetMetadata_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetMetadata_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetMetadata_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetMetadata_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetMetadata_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetMetadata_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetMetadata_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetMetadata_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetMetadata_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetMetadata_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetMetadata_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetMetadata_Response_& instance_data) = 0;

            protected:
                GetMetadata_Response_DataWriter () {};
                ~GetMetadata_Response_DataWriter () {};
            private:
                GetMetadata_Response_DataWriter (const GetMetadata_Response_DataWriter &);
                GetMetadata_Response_DataWriter & operator = (const GetMetadata_Response_DataWriter &);
            };

            class  GetMetadata_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetMetadata_Response_DataReader_ptr _ptr_type;
                typedef GetMetadata_Response_DataReader_var _var_type;

                static GetMetadata_Response_DataReader_ptr _duplicate (GetMetadata_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetMetadata_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetMetadata_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetMetadata_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetMetadata_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetMetadata_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetMetadata_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetMetadata_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetMetadata_Response_& instance) = 0;

            protected:
                GetMetadata_Response_DataReader () {};
                ~GetMetadata_Response_DataReader () {};
            private:
                GetMetadata_Response_DataReader (const GetMetadata_Response_DataReader &);
                GetMetadata_Response_DataReader & operator = (const GetMetadata_Response_DataReader &);
            };

            class  GetMetadata_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetMetadata_Response_DataReaderView_ptr _ptr_type;
                typedef GetMetadata_Response_DataReaderView_var _var_type;

                static GetMetadata_Response_DataReaderView_ptr _duplicate (GetMetadata_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetMetadata_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetMetadata_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetMetadata_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetMetadata_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetMetadata_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetMetadata_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetMetadata_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetMetadata_Response_& instance) = 0;

            protected:
                GetMetadata_Response_DataReaderView () {};
                ~GetMetadata_Response_DataReaderView () {};
            private:
                GetMetadata_Response_DataReaderView (const GetMetadata_Response_DataReaderView &);
                GetMetadata_Response_DataReaderView & operator = (const GetMetadata_Response_DataReaderView &);
            };
            class Sample_GetMetadata_Request_TypeSupportInterface;

            typedef Sample_GetMetadata_Request_TypeSupportInterface * Sample_GetMetadata_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetMetadata_Request_TypeSupportInterface> Sample_GetMetadata_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetMetadata_Request_TypeSupportInterface> Sample_GetMetadata_Request_TypeSupportInterface_out;


            class Sample_GetMetadata_Request_DataWriter;

            typedef Sample_GetMetadata_Request_DataWriter * Sample_GetMetadata_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetMetadata_Request_DataWriter> Sample_GetMetadata_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetMetadata_Request_DataWriter> Sample_GetMetadata_Request_DataWriter_out;


            class Sample_GetMetadata_Request_DataReader;

            typedef Sample_GetMetadata_Request_DataReader * Sample_GetMetadata_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetMetadata_Request_DataReader> Sample_GetMetadata_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetMetadata_Request_DataReader> Sample_GetMetadata_Request_DataReader_out;


            class Sample_GetMetadata_Request_DataReaderView;

            typedef Sample_GetMetadata_Request_DataReaderView * Sample_GetMetadata_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetMetadata_Request_DataReaderView> Sample_GetMetadata_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetMetadata_Request_DataReaderView> Sample_GetMetadata_Request_DataReaderView_out;

            struct Sample_GetMetadata_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetMetadata_Request_, struct Sample_GetMetadata_Request_Seq_uniq_> Sample_GetMetadata_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetMetadata_Request_Seq> Sample_GetMetadata_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetMetadata_Request_Seq> Sample_GetMetadata_Request_Seq_out;

            class  Sample_GetMetadata_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetMetadata_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetMetadata_Request_TypeSupportInterface_var _var_type;

                static Sample_GetMetadata_Request_TypeSupportInterface_ptr _duplicate (Sample_GetMetadata_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetMetadata_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetMetadata_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetMetadata_Request_TypeSupportInterface () {};
                ~Sample_GetMetadata_Request_TypeSupportInterface () {};
            private:
                Sample_GetMetadata_Request_TypeSupportInterface (const Sample_GetMetadata_Request_TypeSupportInterface &);
                Sample_GetMetadata_Request_TypeSupportInterface & operator = (const Sample_GetMetadata_Request_TypeSupportInterface &);
            };

            class  Sample_GetMetadata_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetMetadata_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetMetadata_Request_DataWriter_var _var_type;

                static Sample_GetMetadata_Request_DataWriter_ptr _duplicate (Sample_GetMetadata_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetMetadata_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetMetadata_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetMetadata_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetMetadata_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetMetadata_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetMetadata_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetMetadata_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetMetadata_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetMetadata_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetMetadata_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetMetadata_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetMetadata_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetMetadata_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetMetadata_Request_& instance_data) = 0;

            protected:
                Sample_GetMetadata_Request_DataWriter () {};
                ~Sample_GetMetadata_Request_DataWriter () {};
            private:
                Sample_GetMetadata_Request_DataWriter (const Sample_GetMetadata_Request_DataWriter &);
                Sample_GetMetadata_Request_DataWriter & operator = (const Sample_GetMetadata_Request_DataWriter &);
            };

            class  Sample_GetMetadata_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetMetadata_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetMetadata_Request_DataReader_var _var_type;

                static Sample_GetMetadata_Request_DataReader_ptr _duplicate (Sample_GetMetadata_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetMetadata_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetMetadata_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetMetadata_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetMetadata_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetMetadata_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetMetadata_Request_& instance) = 0;

            protected:
                Sample_GetMetadata_Request_DataReader () {};
                ~Sample_GetMetadata_Request_DataReader () {};
            private:
                Sample_GetMetadata_Request_DataReader (const Sample_GetMetadata_Request_DataReader &);
                Sample_GetMetadata_Request_DataReader & operator = (const Sample_GetMetadata_Request_DataReader &);
            };

            class  Sample_GetMetadata_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetMetadata_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetMetadata_Request_DataReaderView_var _var_type;

                static Sample_GetMetadata_Request_DataReaderView_ptr _duplicate (Sample_GetMetadata_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetMetadata_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetMetadata_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetMetadata_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetMetadata_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetMetadata_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetMetadata_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetMetadata_Request_& instance) = 0;

            protected:
                Sample_GetMetadata_Request_DataReaderView () {};
                ~Sample_GetMetadata_Request_DataReaderView () {};
            private:
                Sample_GetMetadata_Request_DataReaderView (const Sample_GetMetadata_Request_DataReaderView &);
                Sample_GetMetadata_Request_DataReaderView & operator = (const Sample_GetMetadata_Request_DataReaderView &);
            };
            class Sample_GetMetadata_Response_TypeSupportInterface;

            typedef Sample_GetMetadata_Response_TypeSupportInterface * Sample_GetMetadata_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetMetadata_Response_TypeSupportInterface> Sample_GetMetadata_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetMetadata_Response_TypeSupportInterface> Sample_GetMetadata_Response_TypeSupportInterface_out;


            class Sample_GetMetadata_Response_DataWriter;

            typedef Sample_GetMetadata_Response_DataWriter * Sample_GetMetadata_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetMetadata_Response_DataWriter> Sample_GetMetadata_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetMetadata_Response_DataWriter> Sample_GetMetadata_Response_DataWriter_out;


            class Sample_GetMetadata_Response_DataReader;

            typedef Sample_GetMetadata_Response_DataReader * Sample_GetMetadata_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetMetadata_Response_DataReader> Sample_GetMetadata_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetMetadata_Response_DataReader> Sample_GetMetadata_Response_DataReader_out;


            class Sample_GetMetadata_Response_DataReaderView;

            typedef Sample_GetMetadata_Response_DataReaderView * Sample_GetMetadata_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetMetadata_Response_DataReaderView> Sample_GetMetadata_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetMetadata_Response_DataReaderView> Sample_GetMetadata_Response_DataReaderView_out;

            struct Sample_GetMetadata_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetMetadata_Response_, struct Sample_GetMetadata_Response_Seq_uniq_> Sample_GetMetadata_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetMetadata_Response_Seq> Sample_GetMetadata_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetMetadata_Response_Seq> Sample_GetMetadata_Response_Seq_out;

            class  Sample_GetMetadata_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetMetadata_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetMetadata_Response_TypeSupportInterface_var _var_type;

                static Sample_GetMetadata_Response_TypeSupportInterface_ptr _duplicate (Sample_GetMetadata_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetMetadata_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetMetadata_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetMetadata_Response_TypeSupportInterface () {};
                ~Sample_GetMetadata_Response_TypeSupportInterface () {};
            private:
                Sample_GetMetadata_Response_TypeSupportInterface (const Sample_GetMetadata_Response_TypeSupportInterface &);
                Sample_GetMetadata_Response_TypeSupportInterface & operator = (const Sample_GetMetadata_Response_TypeSupportInterface &);
            };

            class  Sample_GetMetadata_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetMetadata_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetMetadata_Response_DataWriter_var _var_type;

                static Sample_GetMetadata_Response_DataWriter_ptr _duplicate (Sample_GetMetadata_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetMetadata_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetMetadata_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetMetadata_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetMetadata_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetMetadata_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetMetadata_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetMetadata_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetMetadata_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetMetadata_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetMetadata_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetMetadata_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetMetadata_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetMetadata_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetMetadata_Response_& instance_data) = 0;

            protected:
                Sample_GetMetadata_Response_DataWriter () {};
                ~Sample_GetMetadata_Response_DataWriter () {};
            private:
                Sample_GetMetadata_Response_DataWriter (const Sample_GetMetadata_Response_DataWriter &);
                Sample_GetMetadata_Response_DataWriter & operator = (const Sample_GetMetadata_Response_DataWriter &);
            };

            class  Sample_GetMetadata_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetMetadata_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetMetadata_Response_DataReader_var _var_type;

                static Sample_GetMetadata_Response_DataReader_ptr _duplicate (Sample_GetMetadata_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetMetadata_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetMetadata_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetMetadata_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetMetadata_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetMetadata_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetMetadata_Response_& instance) = 0;

            protected:
                Sample_GetMetadata_Response_DataReader () {};
                ~Sample_GetMetadata_Response_DataReader () {};
            private:
                Sample_GetMetadata_Response_DataReader (const Sample_GetMetadata_Response_DataReader &);
                Sample_GetMetadata_Response_DataReader & operator = (const Sample_GetMetadata_Response_DataReader &);
            };

            class  Sample_GetMetadata_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetMetadata_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetMetadata_Response_DataReaderView_var _var_type;

                static Sample_GetMetadata_Response_DataReaderView_ptr _duplicate (Sample_GetMetadata_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetMetadata_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetMetadata_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetMetadata_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetMetadata_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetMetadata_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetMetadata_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetMetadata_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetMetadata_Response_& instance) = 0;

            protected:
                Sample_GetMetadata_Response_DataReaderView () {};
                ~Sample_GetMetadata_Response_DataReaderView () {};
            private:
                Sample_GetMetadata_Response_DataReaderView (const Sample_GetMetadata_Response_DataReaderView &);
                Sample_GetMetadata_Response_DataReaderView & operator = (const Sample_GetMetadata_Response_DataReaderView &);
            };
        }

    }

}

#endif
